# -*- coding: utf-8 -*-
"""
Created on Fri Aug 18 12:48:48 2017

@author: phypsh

data structure of input... |T1 (K)|iperm(f1)|T2 (K)|iperm(f2)|T3 (K)|iperm(f3)|
...etc 
"""
import numpy as np
import matplotlib.pyplot as plt
import os
from scipy.optimize import curve_fit
import Stoner.Analysis as SA
import sys

os.chdir(os.path.dirname(sys.argv[0]))#this changes the working directory to the 
                                        #directory the script is in, so will run 
                                        # if input file is there too. 
                                        #Alternatively, get rid of this and change 
                                        # the path below.

path='' #see previous comment
filename='2017-08-22 pinpmnpt001 160-010Kimagperm_vs_T_vs_freq.txt'
outpath=path
newfilename='2017-08-22_pinpmnpt001_imagperm_fmax_vs_Tmax.txt'

def poly8(x,a,b,c,d,e,f,g,h,i):
    """8th order polynomial"""
    return a+b*x+c*x**2.+d*x**3+e*x**4+f*x**5+g*x**6+h*x**7+i*x**8

def peakfitmax(data,n):
    """fit an 8th order polynomial and return the maximum of the peak"""
    print 'fit ', n
    x=data.column(0)
    y=data.column(n)
    p,pcov=curve_fit(poly8,x,y)
    #print p, pcov
    xfit=np.linspace(10,160,100000)
    yfit=poly8(xfit,p[0],p[1],p[2],p[3],p[4],p[5],p[6],p[7],p[8])
    maxifit=np.argmax(yfit)
    tempfit=xfit[maxifit]
    iermaxfit=yfit[maxifit]
    return xfit,yfit,tempfit,iermaxfit

plt.figure(2)
print 'Hello?'
data=SA.AnalyseFile(path+filename)
newdata=SA.AnalyseFile()
for n0 in range(0,len(data.column_headers),2):
    n=n0+1
    if data.column_headers[n][4:-3]=='nan':pass
    if 'Hz' not in data.column_headers[n]:pass
    else:
        freq=float(data.column_headers[n][4:-3])
        if freq>=1. and freq<=10000.:
            try:
                print 'working...'
                maxi=np.argmax(data.column(n))
                temp=data.column(n0)[maxi]
                iermax=data.column(n)[maxi]
                xfit,yfit,tempfit,iermaxfit=peakfitmax(data,n)
                plt.plot(xfit,yfit)
                plt.plot(data.column(0),data.column(n),'o')
                
                print tempfit,iermaxfit
                newdata+=np.array([temp,tempfit,freq,iermax,iermaxfit])
            except ValueError: 
                print 'Skip this one (ValueError)'
                pass
        else: pass
            
newdata.column_headers=['T (K) max','T (K) fitmax','f (Hz)','max ier','fitmax ier']

newdata.sort(1)

print 'finished analysing'

newdata.save(outpath+newfilename)

print 'data saved'